/**
 * Rg[plNX
 */

package tcurve;

import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

class ControlPanel extends Panel implements ActionListener, AdjustmentListener, ItemListener {
    private PHGraph graph;
    private TextFrame textframe;

    private Button btn;
    private Checkbox cb1, cb2, cb3;
    private Choice ch_a, ch_b;
    private Scrollbar sb_sc;

    private Label[] lbl_a = new Label[6];
    private Label[] lbl_b = new Label[6];
    private Scrollbar[] sb_a = new Scrollbar[5];
    private Scrollbar[] sb_b = new Scrollbar[5];

    private String[] acid = {
        "1̋_", "2̋_", "3̋_", "4̋_", "",
        "Ɏ_", "AjECI", "q_", "_", "_", "AjECI", "G`AjECI", "M_",
        "NG_", "N_", "mN|_", "WN|_", "gN|_", "|_", "f_", "VAf_",
        "VA_", "WG`AjECI", "W`AjECI", "VE_", "Ύ_", "Y_", "q_", "qhWjECI",
        "sWjECI", "tFm[", "t^_", "tbf_", "zE_", "`AjECI", "f", "_",
        "_"
    };
    private String[] base = {
        "1̋", "2̋", "3̋", "4̋", "",
        "Ɏ_CI", "Aj", "q_fCI", "_CI", "_CI", "AjA", "G`A~", "M_CI",
        "NG_CI", "N_CI", "mN|_CI", "WN|_CI", "gN|_CI", "|_CI", "f_CI", "VACI",
        "VA_CI", "WG`A~", "W`A~", "VE_CI", "Ύ_CI", "Y_CI", "q_CI", "qhW",
        "sW", "tFm[gCI", "t^_CI", "tbCI", "zE_񐅑fCI", "`A~", "CI", "_CI",
        "_CI"
    };

    private int[][] pka_a = {
        {-200}, {-200, -200}, {-200, -200, -200}, {-200, -200, -200, -200}, {1600},
        {335}, {466}, {920, 1350}, {177, 721}, {418}, {926}, {1075}, {374},
        {308, 474, 540}, {74, 649}, {282}, {130}, {70}, {474}, {750}, {914},
        {370}, {1111}, {1072}, {119, 421}, {303, 454}, {634, 1036}, {226, 677, 1150}, {848},
        {515}, {989}, {289, 541}, {322}, {924}, {1070}, {700, 1500}, {-200, 192},
        {212, 721, 1232}
    };
    private int[][] pka_b = {
        {1600}, {1600, 1600}, {1600, 1600, 1600}, {1600, 1600, 1600, 1600}, {-200},
        {335}, {466}, {920, 1350}, {177, 721}, {418}, {926}, {1075}, {374},
        {308, 474, 540}, {74, 649}, {282}, {130}, {70}, {474}, {750}, {914},
        {370}, {1111}, {1072}, {119, 421}, {303, 454}, {634, 1036}, {226, 677, 1150}, {848},
        {515}, {989}, {289, 541}, {322}, {924}, {1070}, {700, 1500}, {-200, 192},
        {212, 721, 1232}
    };

    ControlPanel(PHGraph graph) {
        this.graph = graph;
        this.textframe = new TextFrame("CSV DATA");

        setLayout(null);

        Panel pnl1 = new Panel(new GridLayout(1, 6));
            CheckboxGroup cbg = new CheckboxGroup();
            pnl1.add(cb1 = new Checkbox("_]H", true, cbg));
            pnl1.add(cb2 = new Checkbox("]_H", false, cbg));
            pnl1.add(cb3 = new Checkbox("dpH/dp \", true));
            pnl1.add(new Label("XP[", Label.CENTER));
            pnl1.add(sb_sc = new Scrollbar(Scrollbar.HORIZONTAL, 35, 1, 5, 101));
            pnl1.add(btn = new Button("f[^o"));
        add(pnl1);
        pnl1.setBounds(0, 0, 550, 17);

        Panel pnl2 = new Panel(new GridLayout(2, 2, 5, 0));
            pnl2.add(lbl_a[5] = new Label("_intj", Label.CENTER));
            pnl2.add(lbl_b[5] = new Label("iHntj", Label.CENTER));
            lbl_a[5].setFont(new Font("SansSerif", Font.PLAIN, 14));
            lbl_b[5].setFont(new Font("SansSerif", Font.PLAIN, 14));
            pnl2.add(ch_a = new Choice());
            pnl2.add(ch_b = new Choice());
            for(int i=0; i<acid.length; i++) ch_a.add(acid[i]);
            for(int i=0; i<base.length; i++) ch_b.add(base[i]);
        add(pnl2);
        pnl2.setBounds(0, 22, 550, 40);

        Panel pnl3 = new Panel(new GridLayout(5, 4, 5, 0));
            pnl3.add(lbl_a[4] = new Label("", Label.LEFT));
            pnl3.add(sb_a[4] = new Scrollbar(Scrollbar.HORIZONTAL, 450, 1, 0, 451));
            pnl3.add(lbl_b[4] = new Label("", Label.LEFT));
            pnl3.add(sb_b[4] = new Scrollbar(Scrollbar.HORIZONTAL, 450, 1, 0, 451));
            for(int i=0; i<4; i++) {
                pnl3.add(lbl_a[i] = new Label("", Label.LEFT));
                pnl3.add(sb_a[i] = new Scrollbar(Scrollbar.HORIZONTAL, 0, 1, -200, 1601));
                pnl3.add(lbl_b[i] = new Label("", Label.LEFT));
                pnl3.add(sb_b[i] = new Scrollbar(Scrollbar.HORIZONTAL, 0, 1, -200, 1601));
            }
        add(pnl3);
        pnl3.setBounds(0, 65, 550, 85);

        setSize(550, 150);

        ch_a.select("_");
        ch_b.select("1̋");

        int n = ch_a.getSelectedIndex();
        int m = pka_a[n].length;
        for(int i=0; i<m; i++) sb_a[i].setValue(pka_a[n][i]);
        for(int i=m; i<4; i++) sb_a[i].setValue(1600);
        n = ch_b.getSelectedIndex();
        m = pka_b[n].length;
        for(int i=0; i<m; i++) sb_b[m - 1 - i].setValue(1400 - pka_b[n][i]);
        for(int i=m; i<4; i++) sb_b[i].setValue(1600);

        check();

        btn.addActionListener(this);
        cb1.addItemListener(this);
        cb2.addItemListener(this);
        cb3.addItemListener(this);
        ch_a.addItemListener(this);
        ch_b.addItemListener(this);
        sb_sc.addAdjustmentListener(this);

        for(int i=0; i<5; i++) {
            sb_a[i].addAdjustmentListener(this);
            sb_b[i].addAdjustmentListener(this);
        }
    }

    private void check() {
        int a, b;

        a = sb_a[4].getValue();
        b = sb_b[4].getValue();
        graph.Ca = (a%90 + 10)/10.0 * Math.pow(10, (a/90) - 6);
        graph.Cb = (b%90 + 10)/10.0 * Math.pow(10, (b/90) - 6);
        lbl_a[4].setText("  Zx  : " + new DecimalFormat("0.0E0").format(graph.Ca) + " mol/L");
        lbl_b[4].setText("  Zx  : " + new DecimalFormat("0.0E0").format(graph.Cb) + " mol/L");

        for(int i=0; i<4; i++) {
            a = sb_a[i].getValue();
            b = sb_b[i].getValue();

            if(a == 1600)
                lbl_a[i].setText("  pKa" + Integer.toString(i+1) + " : ");
            else
                lbl_a[i].setText("  pKa" + Integer.toString(i+1) + " : " + new DecimalFormat("#0.00").format(1.0E-2 * a));
            if(b == 1600)
                lbl_b[i].setText("  pKb" + Integer.toString(i+1) + " : ");
            else
                lbl_b[i].setText("  pKb" + Integer.toString(i+1) + " : " + new DecimalFormat("#0.00").format(1.0E-2 * b));

            graph.Ka[i] = Math.pow(10, -1.0E-2 * a);
            graph.Kb[i] = Math.pow(10, -1.0E-2 * b);
        }
    }

    public void actionPerformed(ActionEvent e) {
        textframe.setText(graph.getCSVData());
        textframe.show();
    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
        if(sb_sc == e.getSource())
            graph.changeScale(sb_sc.getValue()/10.0);
        else
            check();
        graph.repaint();
    }

    public void itemStateChanged(ItemEvent e) {
        if(cb1 == e.getSource()) {
            graph.order = true;
            lbl_a[5].setText("_intj");
            lbl_b[5].setText("iHntj");
        } else if(cb2 == e.getSource()) {
            graph.order = false;
            lbl_a[5].setText("_iHntj");
            lbl_b[5].setText("intj");
        } else if(cb3 == e.getSource()) {
            graph.gradient = !graph.gradient;
        } else if(ch_a == e.getSource()) {
            int n = ch_a.getSelectedIndex();
            int m = pka_a[n].length;
            for(int i=0; i<m; i++) sb_a[i].setValue(pka_a[n][i]);
            for(int i=m; i<4; i++) sb_a[i].setValue(1600);
            check();
        } else if(ch_b == e.getSource()) {
            int n = ch_b.getSelectedIndex();
            int m = pka_b[n].length;
            for(int i=0; i<m; i++) sb_b[m - 1 - i].setValue(1400 - pka_b[n][i]);
            for(int i=m; i<4; i++) sb_b[i].setValue(1600);
            check();
        }
        graph.repaint();
    }
}